import React, { memo, useEffect } from 'react'
import array from 'lodash/array'
import { Line } from 'react-chartjs-2'
import { getRandomColor } from '../utils'

const IncidentsChart = ({ atasks }) => {
  
  let tasks = [...atasks]
  array.reverse(tasks)
  const monthNames = ["January", "February", "March", "April", "May", "June",
    "July", "August", "September", "October", "November", "December"
  ];
  const dates = []
  const counts = []
  const bgColors = []

  useEffect(() => {
    tasks.forEach((t) => {
      const d = new Date(t.created_at)
      const dstr = monthNames[d.getMonth()] + ' ' + d.getFullYear()
      if (dates.indexOf(dstr) === -1) {
        dates.push(dstr)
        counts.push(1)
        bgColors.push(getRandomColor())
      } else {
        counts[dates.indexOf(dstr)] += 1
      }
    })
  }, [])

    return <div className="my-2 h-64 w-full">
      <Line
        data={{
          labels: dates,
          datasets: [{
            data: counts,
            borderColor: 'rgba(29, 78, 216, 1)'
          }],
        }}
        options={{
          maintainAspectRatio: false,
          plugins: {
            legend: {
              display: false,
            },
          },
          scales: {
            yAxis: {
              min: 0
            },
          },
        }}
      />
    </div>

}

export default memo(IncidentsChart)