import React, { memo } from 'react'
import { Pie } from 'react-chartjs-2'
import { getRandomColor } from '../utils'

const ProductsChart = ({ fields, tasks }) => {

  const products = fields[2].options
  const counts = []
  const bgColors = []

  products.forEach(() => {
    counts.push(0)
    bgColors.push(getRandomColor())
  })

  tasks.forEach((t) => {
    if (t.custom_fields[2].enum_value) {
      counts[products.indexOf(t.custom_fields[2].enum_value.name)] += 1
    } else if (t.custom_fields[3].enum_value) {
      counts[products.indexOf(t.custom_fields[3].enum_value.name)] += 1
    }
  })
  
  return <div className="my-2 h-64 w-full">
    <Pie
      data={{
        labels: products,
        datasets: [{
          data: counts,
          backgroundColor: bgColors,
        }],
      }}
      options={{
        maintainAspectRatio: false,
        plugins: {
          legend: {
            position: 'bottom',
          },
        },
      }}
    />
  </div>

}

export default memo(ProductsChart)