import React, { memo } from 'react'
import { Bar } from 'react-chartjs-2'
import { getRandomColor } from '../utils'

const Chart = ({ fields, idx, tasks }) => {

  const labels = fields.options
  const data = []
  const bgColors = []

  labels.forEach((l) => {
    let count = 0
    tasks.forEach((t) => {
      if (t.custom_fields[idx].enum_value != null && t.custom_fields[idx].enum_value.name === l) {
        count += 1
      }
    })
    data.push(count)
    bgColors.push(getRandomColor())
  })

  return <div className="my-2 h-96 w-full md:w-1/2">
    <Bar
      data={{
        labels,
        datasets: [{
          data,
          backgroundColor: bgColors,
        }],
      }}
      options={{
        maintainAspectRatio: false,
        plugins: {
          legend: {
            display: false,
          },
          title: {
            display: true,
            text: fields.name,
            font: {
              size: '20'
            },
          },
        }
      }}
    />
  </div>
}

export default memo(Chart)