import axios from 'axios'

export const getFields = async (setFields) => {
  const fArr = [];
  const res = await axios.get(`${import.meta.env.VITE_ASANA_API_URI}/projects/${import.meta.env.VITE_ASANA_PROJECT_ID}`, {
    headers: {
      Authorization: `Bearer ${import.meta.env.VITE_ACCESS_TOKEN}`
    }
  });
  res.data.data.custom_field_settings.forEach((a) => {
    const f = {
      id: a.gid,
      name: a.custom_field.name,
      type: a.custom_field.type,
    };
    const opts = [];
    if (a.custom_field.type == 'enum') {
      a.custom_field.enum_options.forEach((o) => {
        opts.push(o.name);
      });
      f.options = opts;
    }
    fArr.push(f);
  });
  setFields(fArr);
}

export const getTasks = async (setTasks) => {
  const res2 = await axios.get(`${import.meta.env.VITE_ASANA_API_URI}/tasks`, {
    params: {
      section: '1199915951089746',
      opt_fields: 'name,created_at,custom_fields',
    },
    headers: {
      Authorization: `Bearer ${import.meta.env.VITE_ACCESS_TOKEN}`
    }
  });
  const data = res2.data.data;
  data.sort((a, b) => {
    return new Date(b.created_at) - new Date(a.created_at);
  });
  setTasks(data);
}